package com.taichuan.hardwaredemo.util;

import android.text.TextUtils;
import android.util.Log;

import java.util.regex.Pattern;

/**
 * 该类主要用于
 *
 * @author CamelLuo
 * @version 2020/5/19
 */
public class HexUtils {
    private static final String TAG = HexUtils.class.getSimpleName();

    private static final char HEX_DIGITS[] = {'0', '1', '2', '3', '4', '5',
            '6', '7', '8', '9', 'A', 'B', 'C', 'D', 'E', 'F'};

    public static String getFormatHex(byte[] buff) {
        StringBuilder sb = new StringBuilder();
        for (int i = 1; i <= buff.length; i++) {
            sb.append(HEX_DIGITS[(buff[i - 1] & 0xf0) >>> 4]);
            sb.append(HEX_DIGITS[buff[i - 1] & 0x0f]);
            sb.append(" ");
            if (i % 20 == 0) {
                sb.append("\n");
            } else if (i % 4 == 0) {
                sb.append(" ");
            }
        }
        return sb.toString();
    }

    public static String getFormatHexNonSpace(byte[] buff) {
        StringBuilder sb = new StringBuilder();
        for (int i = 1; i <= buff.length; i++) {
            sb.append(HEX_DIGITS[(buff[i - 1] & 0xf0) >>> 4]);
            sb.append(HEX_DIGITS[buff[i - 1] & 0x0f]);
        }
        return sb.toString();
    }

    public static String getStandardCard(String card) {
        String cardNumResult = null;
        if (!TextUtils.isEmpty(card)) {
            String cardNum = card.trim();
            if (cardNum.length() > 16) {
                cardNum = cardNum.substring(0, 16);
            } else if (cardNum.length() < 16) {
                int addZeroCount = 16 - cardNum.length();

                for(int i = 0; i < addZeroCount; ++i) {
                    cardNum = cardNum + "0";
                }
            }

            if (isHexStrValid(cardNum)) {
                cardNumResult = cardNum;
            } else {
                Log.i(TAG, "getStandardCard: 转换标准卡号失败，卡号非16进制字符范围内： " + cardNum);
            }
        }

        return cardNumResult;
    }

    public static boolean isHexStrValid(String str) {
        String pattern = "^[0-9a-fA-F]+$";
        return Pattern.compile(pattern).matcher(str).matches();
    }
}
